import java.util.ArrayList;
import java.util.List;

/**
 * A knowledge base in CNF form
 */
public class KnowledgeBase {
	/**
	 * The list of clauses
	 */
	private List<Clause> clauses;
	
	public KnowledgeBase(List<Clause> clauses) {
		this.clauses = new ArrayList<Clause>(clauses);
	}

	public List<Clause> getClauses() {
		return clauses;
	}

	public void setClauses(List<Clause> clauses) {
		this.clauses = clauses;
	}
	
	public boolean equals(Object o) {
		if (o instanceof KnowledgeBase) {
			KnowledgeBase kb = (KnowledgeBase) o;
			return clauses.containsAll(kb.clauses) && 
				kb.clauses.containsAll(clauses);
		} else {
			return false;
		}
	}
	
	public int hashCode() {
		int result = 0;
		for (Clause c : clauses) {
			result += c.hashCode();
		}
		return result;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("(");
		for (int i = 0; i < clauses.size(); i++) {
			sb.append(clauses.get(i).toString());
			if (i + 1 < clauses.size()) {
				sb.append(" && ");
			}
		}
		sb.append(")");
		return sb.toString();
	}

	public boolean walkSAT(double p, int maxFlips) {
		// TODO: implement walkSAT
		return false;
	}

}
